/********************************************************************** 
 Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/

#ifndef FC__FC_TYPES_H
#define FC__FC_TYPES_H
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

#define TRUE true
#define FALSE false


#define MAX_LEN_NAME 32

#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))


typedef int Nation_Type_id;
typedef int Unit_Type_id;

struct player {
  char name[MAX_LEN_NAME];

  Nation_Type_id nation;
  int player_no;
};

struct city {
  char name[MAX_LEN_NAME];

  int owner;
  struct tile *tile;

  int id;
};

struct unit {
  Unit_Type_id type;
  int owner;
  int homecity;
  struct tile *tile;

  int id;
};

struct tile {
  const int nat_x, nat_y;

  const int index;
};

struct impr_type {
  const char *name;

  char name_orig[MAX_LEN_NAME];

  const int index;
};

struct nation_type {
  const char *name;
  const char *name_plural;

  char name_orig[MAX_LEN_NAME];
  char name_plural_orig[MAX_LEN_NAME];

  const int index;
};

struct unit_type {
  const char *name;

  char name_orig[MAX_LEN_NAME];

  const int index;
};

#endif

