#include <stdio.h>

#include "idex.h"

#include "fc_types.h"

#include "script.h"

struct player *pplayer;

int main(int argc, char *argv[])
{
  struct city *pcity;
  struct unit *punit;

  if (argc < 2) {
    printf("please give me a lua script filename.\n");
    return 1;
  }

  idex_init();

  script_init();

  pplayer = malloc(sizeof(*pplayer));
  pplayer->player_no = 10;
  strcpy(pplayer->name, "Toto");

  punit = malloc(sizeof(*punit));
  punit->id = 69;
  punit->owner = 0;
  punit->homecity = 6969;
  idex_register_unit(punit);

  pcity = malloc(sizeof(*pcity));
  strcpy(pcity->name, "Kansas");
  pcity->id = 6969;
  pcity->owner = 0;
  idex_register_city(pcity);

  script_signal_new("turn", -1);
  script_signal_new("hut_enter", API_TYPE_UNIT, -1);

  script_do_file(argv[1]);

  script_signal_emit("turn", -1);
  script_signal_emit("turn", -1);

  script_signal_emit("hut_enter", API_TYPE_UNIT, punit, -1);

  script_free();

  idex_free();
  return 0;
}

