/**********************************************************************
 Freeciv - Copyright (C) 2005 - The Freeciv Project
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/

#ifndef FC__SCRIPT_H
#define FC__SCRIPT_H

#include <stdarg.h>

enum api_types {
  API_TYPE_INT,
  API_TYPE_BOOL,
  API_TYPE_STRING,

  API_TYPE_PLAYER,
  API_TYPE_CITY,
  API_TYPE_UNIT,
  API_TYPE_TILE
};

/* signal functions. */
void script_signal_emit_valist(const char *signal_name, va_list args);
void script_signal_emit(const char *signal_name, ...);

void script_signal_new_valist(const char *signal_name, va_list args);
void script_signal_new(const char *signal_name, ...);

void script_signal_connect(const char *signal_name, const char *callback_name);

/* internal api error function. */
void script_error(const char *message);

/* script functions. */
bool script_init(void);
void script_free(void);
bool script_do_file(const char *filename);

#endif

